"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateTsModels = exports.nrsrxValuePropertyTypeFilterCallBack = exports.nrsrxTypeFilterCallBack = void 0;
var fs = require("fs");
var generators_1 = require("./generators");
var generator_options_1 = require("./models/generator-options");
var openapidoc_converter_1 = require("./openapidoc-converter");
var axios_1 = require("axios");
var nrsrx_filters_1 = require("./models/nrsrx-filters");
Object.defineProperty(exports, "nrsrxTypeFilterCallBack", { enumerable: true, get: function () { return nrsrx_filters_1.nrsrxTypeFilterCallBack; } });
Object.defineProperty(exports, "nrsrxValuePropertyTypeFilterCallBack", { enumerable: true, get: function () { return nrsrx_filters_1.nrsrxValuePropertyTypeFilterCallBack; } });
function generateTsModels(options) {
    return __awaiter(this, void 0, void 0, function () {
        var apiDocument, converter, templateData;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    options = (0, generator_options_1.setGeneratorOptionDefaults)(options);
                    return [4 /*yield*/, getOpenApiDocumentAsync(options)];
                case 1:
                    apiDocument = _a.sent();
                    converter = new openapidoc_converter_1.OpenApiDocConverter(options, apiDocument);
                    templateData = converter.convertDocument();
                    generateOutput(options, templateData);
                    return [2 /*return*/];
            }
        });
    });
}
exports.generateTsModels = generateTsModels;
function getOpenApiDocumentAsync(options) {
    return __awaiter(this, void 0, void 0, function () {
        var apiDoc, response, response;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!options.openApiJsonUrl) return [3 /*break*/, 2];
                    return [4 /*yield*/, axios_1.default.get(options.openApiJsonUrl, options.axiosConfig)];
                case 1:
                    response = _a.sent();
                    apiDoc = response.data;
                    return [3 /*break*/, 3];
                case 2:
                    if (options.openApiJsonFileName) {
                        response = fs.readFileSync("".concat(__dirname, "/").concat(options.openApiJsonFileName));
                        apiDoc = JSON.parse(response.toString());
                    }
                    else {
                        throw new Error('You must specify either an OpenApi Json Url or FileName.  Please review the readme.md @ https://github.com/ikemtz/openapi-ts-generator.');
                    }
                    _a.label = 3;
                case 3: return [2 /*return*/, apiDoc];
            }
        });
    });
}
function generateOutput(options, templateData) {
    if (fs.existsSync(options.outputPath)) {
        fs.readdirSync(options.outputPath).forEach(function (file) { return fs.unlinkSync("".concat(options.outputPath, "/").concat(file)); });
        fs.rmdirSync(options.outputPath);
    }
    fs.mkdirSync(options.outputPath, { recursive: true });
    var modelGenerator = new generators_1.ModelGenerator(options);
    modelGenerator.generate(templateData);
    if (options.genAngularFormGroups) {
        var formGroupGenerator = new generators_1.FormGroupFactoryGenerator(options);
        formGroupGenerator.generate(templateData);
        var formGenerator = new generators_1.FormGenerator(options);
        formGenerator.generate(templateData);
    }
    var modelPropertiesGenerator = new generators_1.ModelPropertiesGenerator(options);
    modelPropertiesGenerator.generate(templateData);
    var endpointGenerator = new generators_1.EndPointsGenerator(options);
    endpointGenerator.generate(templateData);
    var barrelGenerator = new generators_1.BarrelGenerator(options);
    var enumGenerator = new generators_1.EnumGenerator(options);
    enumGenerator.generate(templateData);
    var testObjFacGenerator = new generators_1.TestObjectFactoryGenerator(options);
    testObjFacGenerator.generate(templateData);
    barrelGenerator.generate();
}
